
### A demonstration XBEL to HTML converter using DOM

from xml.dom import core,sax_builder
from xml.sax import saxexts
import sys,dom_load

# --- Utility functions

def join_contents(node):
    res=""
    for child in node.get_childNodes():
        res=res+child.get_data()
    # oops, will include PIs and comments
    return res

def get_first_child(parent,element_type):
    for child in parent.get_childNodes():
        if child.get_nodeType()==core.ELEMENT and \
           child.get_tagName()==element_type:
            return child

def handle_folder(folder):
    out.write("<UL>\n")

    for child in folder.get_childNodes():
        if child.get_nodeType()==core.ELEMENT:
            if child.get_tagName()=="folder":
                title=get_first_child(child,"title")
                if title:
                    title=join_contents(title)
                else:
                    title="?"

                out.write("  <LI><B>%s</B>\n" % title)
                handle_folder(child)
            elif child.get_tagName()=="bookmark":
                url=child.getAttribute("href")
                
                title=get_first_child(child,"title")
                if title:
                    title=join_contents(title)
                else:
                    title="?"
                    
                desc=get_first_child(child,"desc")
                if desc:
                    desc=join_contents(desc)
                else:
                    desc=""

                out.write('  <LI><A HREF="%s">%s</A>. %s\n' %
                          (url,title,desc))
                    
    out.write("</UL>\n")
    

# --- Templates

top=\
"""
<HTML>
<HEAD>
  <TITLE>%s</TITLE>
</HEAD>

<BODY>
<H1>%s</H1>

"""

bottom=\
"""
<HR>

<ADDRESS>
Converted by xbel2html.
</ADDRESS>

</BODY>
</HTML>
"""

# --- Converting

out=sys.stdout

doc=dom_load.parse(sys.argv[1])
root=doc.get_documentElement()

# Title

title=get_first_child(root,"title")
if title:
    title=join_contents(title)
else:
    title="Bookmarks"

out.write(top % ("Bookmarks","Bookmarks"))

# Description

desc=get_first_child(root,"desc")
if desc:
    out.write("<P>%s</P>\n" % join_contents(desc))

# Bookmarks/folders

handle_folder(root)

# Bottom

out.write(bottom)
