
<!--

 Thanks to Alistair MacDonald for helping me out here.

-->
	
<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl"
  xmlns:html="http://www.w3.org/TR/REC-html40"
  result-ns="html">

  <xsl:template match="rfc-index">
    <html:html>
    <html:head>
      <html:title>An index of RFCs</html:title>
    </html:head>

    <html:body>
    <html:h1>An index of RFCs</html:h1>

    <html:h2>RFCs by number</html:h2>
    <html:p>
    <xsl:apply-templates mode="by-number">
      <xsl:sort select="./number" data-type="number"/>
    </xsl:apply-templates>
    </html:p>

    <html:h2>RFCs by standard</html:h2>
    <html:p>
    <xsl:apply-templates mode="by-standard">
      <xsl:sort select="./standard"/>
    </xsl:apply-templates>
    </html:p>
        
    <html:h2>RFCs by category</html:h2>
    <xsl:apply-templates/>
    </html:body>
    </html:html>
  </xsl:template>

  <!-- BY STANDARD -->

  <xsl:template match="category" mode="by-standard">
    <xsl:apply-templates mode="by-standard"/>
  </xsl:template>
  
  <xsl:template match="rfc" mode="by-standard">
    <xsl:if test=".[./standard]">
    <html:a href="#rfc{./number}"><xsl:value-of select="./standard"/></html:a>
    </xsl:if>
  </xsl:template>
  
  <!-- BY NUMBER -->

  <xsl:template match="category" mode="by-number">
    <xsl:apply-templates mode="by-number"/>
    <xsl:if test=".[not(last-of-type())]"> | </xsl:if>
  </xsl:template>
  
  <xsl:template match="rfc" mode="by-number">
    <html:a href="#rfc{./number}"><xsl:value-of select="./number"/></html:a>
    <xsl:if test=".[not(last-of-type())]"> | </xsl:if>
  </xsl:template>

  <!-- BY CATEGORY -->

  <xsl:template match="category">
    <html:h3><xsl:value-of select="./name"/></html:h3>

    <html:ul>
    <xsl:apply-templates select="rfc">
      <xsl:sort select="./number" data-type="number"/>
    </xsl:apply-templates>
    </html:ul>
  </xsl:template>

  <xsl:template match="rfc">
    <html:li><html:a name="rfc{./number}"
                     href="ftp://sunsite.uio.no/pub/rfc/rfc{./number}.txt">RFC
             <xsl:value-of select="./number"/></html:a>

    <xsl:choose>
      <xsl:when test="./nickname">
        <xsl:apply-templates select="nickname"/>
      </xsl:when>
      <xsl:otherwise>
        - <xsl:apply-templates select="title"/>
      </xsl:otherwise>
    </xsl:choose>
    
    <!-- if it has a nickname, use that, if not, use the title -->
    
    </html:li>
  </xsl:template>

  <xsl:template match="nickname">
  - <xsl:value-of select="."/>
  </xsl:template>
  
  <!-- IGNORES -->

  <xsl:template match="number|head|name" mode="by-standard" />
  <xsl:template match="number|head|name" mode="by-number" />
  <xsl:template match="number|head|name">
  </xsl:template>
  
</xsl:stylesheet>
