
import string,sys
from xml.sax import saxlib,saxexts,saxutils

# --- ESIS document handler (actually stolen from saxutils :)

def replace_newlines(str):
    return string.replace(str,"\n","\\n")

class ESISDocHandler(saxlib.HandlerBase):
    "A SAX document handler that produces naive ESIS output."

    def __init__(self,writer=sys.stdout):
	self.writer=writer
    
    def processingInstruction (self,target, remainder):
	self.writer.write("?"+target+" "+remainder+"\n")

    def startElement(self,name,amap):
	self.writer.write("("+name+"\n")
	for a_name in amap.keys():
	    self.writer.write("A"+a_name+" "+replace_newlines(amap[a_name])+
                              "\n")

    def endElement(self,name):
	self.writer.write(")"+name+"\n")

    def characters(self,data,start_ix,length):
	self.writer.write("-"+replace_newlines(data[start_ix:start_ix+length])+
                                               "\n")

# --- Main program

p=saxexts.make_parser()

# <changes>
import filters
p.setDocumentHandler(filters.BlockDataFilter(filters.WSFilter(ESISDocHandler(),filters.WSFilter.NORMALIZE)))
# </changes>

p.setErrorHandler(saxutils.ErrorRaiser())

try:
    p.parse(sys.argv[1])
except saxlib.SAXException,e:
    print "Error when parsing: "+str(e)
    print "Parse aborted"
