<!--
  A demonstration XSL stylesheet for converting XBEL documents to HTML.
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl"
                xmlns:html="http://www.w3.org/TR/REC-html40"
		result-ns="html">

  <xsl:template match="xbel">
    <html:html>
    <html:head>
      <title>Bookmarks</title>
    </html:head>
    
    <html:body>
      <xsl:apply-templates/>

    <html:hr/>
    <html:address>
    Converted to HTML with xbel.xsl.
    </html:address>
    
    </html:body>
    </html:html>
  </xsl:template>

  <xsl:template match="xbel/title">
    <html:h1><xsl:apply-templates/></html:h1>
  </xsl:template>

  <xsl:template match="desc">
    <html:p><xsl:apply-templates/></html:p>
  </xsl:template>

  <xsl:template match="bookmark">
    <html:li><xsl:apply-templates/></html:li>
  </xsl:template>

  <xsl:attribute-set name="url">
    <xsl:attribute name="href"></xsl:attribute>
  </xsl:attribute-set>
  
  <xsl:template match="bookmark/title">
    <html:b><html:a><xsl:use attribute-set="url"/>
      <xsl:apply-templates/>
    </html:a></html:b>
  </xsl:template>
  
</xsl:stylesheet>