<!--
  A demonstration XSL stylesheet for converting XBEL documents to HTML.
  Slightly more advanced than the first one.
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl"
                xmlns:html="http://www.w3.org/TR/REC-html40"
		result-ns="html">

  <xsl:template match="xbel">
    <html:html>
    <html:head>
      <html:title>Bookmarks</html:title>
    </html:head>
    
    <html:body>
      <xsl:apply-templates/>

    <html:ul>
      <xsl:apply-templates mode="bookmarks"/>
    </html:ul>
      
    <html:hr/>
    <html:address>
    Converted to HTML with xbel.xsl.
    </html:address>
    
    </html:body>
    </html:html>
  </xsl:template>

  <xsl:template match="xbel/title">
    <html:h1><xsl:apply-templates/></html:h1>
  </xsl:template>

  <xsl:template match="desc">
    <html:p><xsl:apply-templates/></html:p>
  </xsl:template>

  <xsl:template match="bookmark">
  </xsl:template>

  <xsl:template match="folder">
  </xsl:template>
    
  <!-- Bookmarks mode -->

  <xsl:template match="bookmark" mode="bookmarks">
    <html:li><xsl:apply-templates mode="bookmarks"/></html:li>
  </xsl:template>
  
  <xsl:template match="bookmark/title" mode="bookmarks">
    <html:a href="{../@href}">
      <xsl:apply-templates/>
    </html:a>
  </xsl:template>

  <xsl:template match="bookmark/desc">
    <xsl:apply-templates/>
  </xsl:template>
  
  <xsl:template match="folder" mode="bookmarks">
    <html:li><html:b>
      <xsl:value-of select="./title/text()"/>
    </html:b></html:li>
    
    <html:ul>
      <xsl:apply-templates mode="bookmarks"/>
    </html:ul>
  </xsl:template>
  
  <!-- Dummies -->
  
  <xsl:template match="xbel/desc" mode="bookmarks">
  </xsl:template>

  <xsl:template match="xbel/title" mode="bookmarks">
  </xsl:template>    

  <xsl:template match="folder/title" mode="bookmarks">
  </xsl:template>    
      
</xsl:stylesheet>