<!--
  A demonstration XSL stylesheet for converting XBEL documents to HTML.
  Improves xbel2.xsl by using common idioms, thus simplifying it and
  at the same time adding more functionality.
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl"
                xmlns:html="http://www.w3.org/TR/REC-html40"
		result-ns="html">

  <xsl:template match="xbel">
    <html:html>
    <html:head>
      <html:title><xsl:value-of select="title"/></html:title>
    </html:head>
    
    <html:body>
      <html:h1><xsl:value-of select="title"/></html:h1>
      <html:p><xsl:value-of select="desc"/></html:p>

    <html:ul>
      <xsl:apply-templates/>
    </html:ul>
      
    <html:hr/>
    <html:address>
    Converted to HTML with xbel.xsl.
    </html:address>
    
    </html:body>
    </html:html>
  </xsl:template>
    

  <xsl:template match="bookmark">
    <html:li><xsl:apply-templates/></html:li>
  </xsl:template>
  
  <xsl:template match="bookmark/title">
    <html:a href="{../@href}">
      <xsl:apply-templates/>
    </html:a>
  </xsl:template>

  <xsl:template match="bookmark/desc">
    <xsl:apply-templates/>
  </xsl:template>
  
  <xsl:template match="folder">
    <html:li><html:b>
      <xsl:value-of select="./title/text()"/>
    </html:b></html:li>
    
    <html:ul>
      <xsl:apply-templates/>
    </html:ul>
  </xsl:template>
  
  <!-- Dummies -->
  
  <xsl:template match="xbel/desc|xbel/title|folder/title"/>
        
</xsl:stylesheet>